;	M4RMT/ASM
;	SEND	I-INITIATE
IINIT	LD	A,(NUMTRY)	; GET THE NUMBER OF TRIES.
	CP	IMXTRY		; HAVE WE REACHED THE MAX NUM OF TRIES?
	JP	M,IINIT2
	LD	DE,ERMS14
	CALL	ERROR3		; DISPLAY ERMSG
	JP	ABORT		; CHANGE THE STATE TO ABORT.
IINIT2	INC	A		; INCREMENT IT.
	LD	(NUMTRY),A	; SAVE THE UPDATED NUMBER OF TRIES.
	LD	A,'1'		; RESET TO USE SINGLE CHARACTER CHECKSUM
	LD	(CURCHK),A	; FOR STARTUP
	LD	A,(CHKTYP)	; GET OUR DESIRED BLOCK CHECK TYPE
	LD	(INICHK),A
	LD	HL,DATA		; GET A POINTER TO OUR DATA BLOCK.
	CALL	RPAR		; SET UP THE PARAMETER INFORMATION.
	LD	(ARGBLK+1),A	; SAVE THE NUMBER OF ARGUMENTS.
	LD	A,(NUMPKT)	; GET THE PACKET NUMBER.
	LD	(ARGBLK),A
	LD	A,'I'		; SEND INITIATE PACKET.
	CALL	SPACK		; SEND THE PACKET.
	JP	ABORT		;  FAILED, ABORT.
	CALL	RPACK		; GET A PACKET.
	JP	QUIT		;  TRASHED PACKET, RETRY.
	CP	'Y'		; ACK?
	JP	NZ,IINIT3	; IF NOT TRY NEXT.
	LD	A,(PKTNUM)	; GET THE PACKET NUMBER.
	LD	B,A
	LD	A,(ARGBLK)
	CP	B		; IS IT THE RIGHT PACKET NUMBER?
	RET	NZ 		; IF NOT TRY AGAIN.
	INC	A		; INCREMENT THE PACKET NUMBER.
	AND	3FH		; TURN OFF THE TWO HIGH ORDER BITS.
	LD	(PKTNUM),A	; SAVE MODULO 64 OF THE NUMBER.
	LD	HL,(NUMPKT)
	INC	HL		; INCREMENT THE NUMBER OF PACKETS.
	LD	(NUMPKT),HL
	LD	A,(ARGBLK+1)	; GET THE NUMBER OF PIECES OF DATA.
	LD	HL,DATA		; POINTER TO THE DATA.
	CALL	SPAR		; READ IN THE DATA.
	LD	A,(NUMTRY)	; GET THE NUMBER OF TRIES.
	LD	(OLDTRY),A	; SAVE IT.
	XOR	A
	LD	(NUMTRY),A	; RESET THE NUMBER OF TRIES.
	LD	A,(INICHK)	; GET THE AGREED UPON BLOCK-CHECK-TYPE
	LD	(CURCHK),A	; STORE AS TYPE TO USE FOR PACKETS NOW
	LD	A,'F'		; SET THE STATE TO FILE SEND
	LD	(STATE),A
	RET	
IINIT3	CP	'N'		; NAK?
	JP	NZ,IINIT4	; IF NOT SEE IF ITS AN ERROR.
	CALL	UPDRTR		; UPDATE THE NUMBER OF RETRIES.
	LD	A,(PKTNUM)	; GET THE PRESENT PACKET NUMBER.
	INC	A		; INCREMENT.
	LD	B,A
	LD	A,(ARGBLK)	; GET THE PACKET'S NUMBER.
	CP	B		; IS THE PACKET'S NUMBER ONE MORE THAN NOW?
	RET	NZ 		; IF NOT ASSUME FOR THIS PACKET, GO AGAIN.
	XOR	A
	LD	(NUMTRY),A	; RESET NUMBER OF TRIES.
	LD	A,'F'		; SET THE STATE TO FILE SEND.
	LD	(STATE),A
	RET	
IINIT4	CP	'E'		; IS IT AN ERROR PACKET.
	JP	NZ,ABORT
	CALL	ERROR
	JP	ABORT
;	REMOTE KERMIT COMMAND
REMOTE	LD	A,CMKEY
	LD	DE,RMTTAB
	CALL	COMND
	JP	KERMT2
	LD	C,A		;SAVE THE TYPE
	LD	A,CMTXT		;GET OUR ARGUMENT DATA
	LD	DE,DATA		;WHERE WE PUT IT
	CALL	COMND
	JP	KERMT3		;SAY NOT CONFIRMED
	LD	B,0
	LD	HL,RMTJTB	;GET THE JUMP TABLE
	ADD	HL,BC		;COMPUTE THE ADDRESS
	JP	(HL)
;	REMOTE COMMAND JUMP TABLE
RMTJTB	JP	RMTCWD		;CHANGE WORKING DIRECTORIES
	JP	RMTDEL		;DELETE A FILE
	JP	RMTDIR		;DISPLAY A DIRECTORY
	JP	RMTDSK		;DO A REMOTE DISK ALLOCATION
	JP	RMTHLP		;GET REMOTE HELP
	JP	RMTHST		;DO REMOTE HOST COMMAND
	JP	RMTKER		;DO REMOTE KERMIT COMMAND
	JP	RMTRUN		;RUN A REMOTE PROGRAM
	JP	RMTPRG		;SEND DATA TO A REMOTE PROGRAM
	JP	RMTTYP		;DISPLAY A REMOTE FILE
RMTDEL	EQU	$
RMTDIR	EQU	$
RMTDEL	EQU	$
RMTDSK	EQU	$
RMTHLP	EQU	$
RMTHST	EQU	$
RMTKER	EQU	$
RMTRUN	EQU	$
RMTRUN	EQU	$
RMTPRG	EQU	$
RMTTYP	EQU	$
;	CHANGE REMOTE WORKING DIRECTORY
RMTCWD	LD	DE,RMTSTR
	CALL	PRTSTR
	JP	KERMIT
RMTSTR	DB	CR,16,'Remote command not fully implemented!',17,CR,'$'

